// Un cartable...
#include "golds.inc"

#declare TCuir=texture{
	normal { granite scale 2}
	pigment { Brown }
}

#declare Fermoir=merge{
	box { <0,0,0>, <0.5, 0.4, 0.1> }
	box { <0.05,0,0>, <0.40, 0.15, 0.25>
		rotate -x*15
		translate y*0.05
	}

	translate <-0.25, -0.3, -0.1>
	scale 0.5 

	texture { T09 } 
}

#declare CartBody=merge {

	// Devant
	bicubic_patch { type 1
		flatness 0.01
		u_steps 3
		v_steps 3
		<-1.5,1.5,-0.3>,   <-0.5,1.5,-0.2>,   <0.5,1,-0.4>,     <1.5,1.5,-0.3>,
		<-1.5,1,-0.4>,     <-0.5,1,-0.2>,     <0.5,1,-0.1>,     <1.5,1,-0.4>,
		<-1.5,0.5,-0.4>,   <-0.5,0.5,-0.1>,   <0.5,0.5,-0.3>,   <1.5,0.5,-0.4>,
		<-1.5,0,-0.4>,     <-0.5,0,-0.4>,     <0.5,0,-0.4>,     <1.5,0,-0.4>
	}

	// Cote grauche
	bicubic_patch { type 1
		flatness 0.01
		u_steps 3
		v_steps 3
		<-1.5, 1.5, 0.5> ,  <-1.1, 1.4, 0.2>  , <-1.3, 1.4, -0.1>  , <-1.5, 1.5, -0.3>,
		<-1.5, 1  , 0.5> ,  <-1.3, 1,   0.2>  , <-1.3, 1  , -0.1>  , <-1.5, 1,   -0.4>,
		<-1.5, 0.5, 0.5> ,  <-1.4, 0.5, 0.2>  , <-1.3, 0.5, -0.1>  , <-1.5, 0.5, -0.4>,
		<-1.5, 0,   0.5> ,  <-1.5, 0,   0.2>  , <-1.5, 0,   -0.1>  , <-1.5, 0,   -0.4>

	}

	// Dessous
	bicubic_patch { type 1
		flatness 0.01
		u_steps 3
		v_steps 3
		< 1.5, 0.0, 0.5> , < 1.5, 0.0, 0.2> , <-1.5, 0.0,-0.1> , < 1.5, 0.0,-0.4> ,
		< 0.5, 0.0, 0.5> , < 0.5, 0.1, 0.2> , < 0.5, 0.2,-0.1> , < 0.5, 0.0,-0.4> , 
		<-0.5, 0.0, 0.5> , <-0.5, 0.2, 0.2> , <-0.5, 0.1,-0.1> , <-0.5, 0.0,-0.4> , 
		<-1.5, 0.0, 0.5> , <-1.5, 0.0, 0.2> , <-1.5, 0.0,-0.1> , <-1.5, 0.0,-0.4>
	}

	// Cote Droit
	bicubic_patch { type 1
		flatness 0.01
		u_steps 3
		v_steps 3
		<1.5, 1.5, 0.5> ,  <1.1, 1.4, 0.2>  , < 1.3, 1.4, -0.1>  , < 1.5, 1.5, -0.3>,
		<1.5, 1  , 0.5> ,  <1.3, 1,   0.2>  , < 1.3, 1  , -0.1>  , < 1.5, 1,   -0.4>,
		<1.5, 0.5, 0.5> ,  <1.4, 0.5, 0.2>  , < 1.3, 0.5, -0.1>  , < 1.5, 0.5, -0.4>,
		<1.5, 0,   0.5> ,  <1.5, 0,   0.2>  , < 1.5, 0,   -0.1>  , < 1.5, 0,   -0.4>
	}

	// Fond
	bicubic_patch { type 1
		flatness 0.01
		u_steps 3
		v_steps 3
		<-1.5, 1.5, 0.5> , <-0.5, 1.5, 0.5> , < 0.5, 1.5, 0.5> , < 1.5, 1.5, 0.5>,
		<-1.5, 1  , 0.5> , <-0.5, 1.0, 0.4> , <-0.5, 1.0, 0.3> , < 1.5, 1.0, 0.5> ,
		<-1.5, 0.5, 0.5> , <-0.5, 0.5, 0.3> , <-0.5, 0.5, 0.4> , < 1.5, 0.5, 0.5> , 
		<-1.5, 0,   0.5> , <-0.5, 0.0, 0.5> , < 0.5, 0.0, 0.5> , < 1.5, 0.0, 0.5>
	}

	texture {TCuir}
}


#declare CartDessus=merge {
	difference {
		cylinder {
			<-1.5, 1.5, -0.1>,
			<1.5,1.5, -0.1>, 0.6
			open
		}

		box { <-2, 1.5,-1>, <2,0.5,1> }
	}

	smooth_triangle {
		<-1.5, 1.5, -0.7>, <0,0,-0.5>
		<1.5, 1.5, -0.7>, <0,0,-0.5>
		<-1.5, 0.75, -0.55>, <0,-0.15,-0.5>
	}

	smooth_triangle {
		<1.5, 1.5, -0.7>, <0,0,-0.5>,
		< -1.5, 0.75, -0.55>, <0,-0.15,-0.5>,
		<1.5,0.75,-0.65>, <0,-0.15,-0.5>
	}

	texture {TCuir}

}

#declare Cartable=union {
	object {CartDessus}
	object {CartBody}
	object {Fermoir translate <-1, 0.75, -0.55> }
	object {Fermoir translate <1, 0.75, -0.65> }
	translate -z*0.5
	scale 2
}

